#!/bin/sh
# ************************************************
# * Fritz!Dect 200 Steckdosen ein/ausschalten    *
# *                                              *
# * zusammengestellt und angepasst von           *
# * fred_feuerstein (NG-Team), LoginTeil zur     *
# * Ermittlung der FritzBox SID von SnowHead und *
# * Theobald123 (Keywelt)                        *
# *                                              *
# * Das Plugin/Skript schaltet eine Fritz!Dect200*
# * Steckdose von AVM, die mit der FritzBox ge-  *
# * koppelt ist.                                 *
# *                                              *
# * Vorbereitung:                                *
# * die Login-Daten fuer die FritzBox werden aus *
# * der FritzCallMonitor.cfg geholt. Bitte die   *
# * Datei vorher anpassen.                       *
# * ausserdem die AIN-Nummer der FritzDect 200   *
# * (steht im Webinterface der Fritzbox)         *
# ************************************************


# feste Zeiten (manuell) oder dynamisch (auto) nach SunUpDown.txt
# Bitte einstellen entwerder "auto" oder "manuell"

schalter="auto"

if [ "$schalter" = "auto" ]; then
    #Sonnenauf-/untergang werden aus dieser Datei geholt
    SUNUPDOWN=$(cat /var/tuxbox/config/SunUpDown.txt)
    STARTTIME=`echo "$SUNUPDOWN" | grep $(date +%d.%m.) | cut -c 13-16`
    ENDTIME=`echo "$SUNUPDOWN" | grep $(date +%d.%m.) | cut -c 8-11`
    echo "Uhrzeit zwischen Sonnenuntergang um" $STARTTIME "Uhr und Sonnenaufgang um" $ENDTIME "Uhr"
  else
    #Feste Zeiten zwischen Uhrzeiten von Starttime bis Endtime (21:00 Uhr => 2100)
    STARTTIME="1830"
    ENDTIME="0730"
fi


# ab hier keine Eintragung mehr nötig
#################################################

# Die Config-Daten werden aus der smarthomeinfo.cfg geholt
CONFIG=$(cat /var/tuxbox/config/smarthomeinfo.conf)

#Daten aus Config
FRITZIP=`echo "$CONFIG" | grep '^FRITZBOXIP' | cut -d "=" -f2 | tr -d ' '`
Passwd=`echo "$CONFIG" | grep '^PASSWD' | cut -d "=" -f2 | tr -d ' '`
USERNAME=`echo "$CONFIG" | grep '^USERNM' | cut -d "=" -f2 | tr -d ' '`
DECT200=`echo "$CONFIG" | grep FRITZDECT1 | cut -d "=" -f2 | tr -d ' '`

teil1=`echo $DECT200 | cut -c 1-5`
teil2=`echo $DECT200 | cut -c 6-20`

if [ "$teil1" != "08761" ]; then
   getrennt=$DECT200
   else
   getrennt=`echo $teil1 $teil2`
fi

if [ $STARTTIME -le $(date +%H%M) ] || [ $(date +%H%M) -le $ENDTIME ]; then

echo "FritzDect_timeon - JA - Steckdose einschalten"
# OS-Version ermitteln
#Version=`wget -O - http://$FRITZIP/jason_boxinfo.xml | grep Version | awk '{match($0,/>[^<>]+</); print substr($0,RSTART+4,5)}'`
Version=`wget -O- http://$FRITZIP/jason_boxinfo.xml | grep Version | awk '{match($0,/>[^<>]+</); print substr($0,RSTART+RLENGTH-6,5)}'`
echo "FritzDect_timeon - Fritzbox-Software V"$Version" "

if [ "$Version" \< "05.50" ]; then
  echo "FritzDect_timeon - alte Login-Version <05.50"
	# Challenge abholen
	ChallengeXML=`wget -O - "http://$FRITZIP/cgi-bin/webcm?getpage=../html/login_sid.xml" 2>/dev/null| grep Challenge`
	Challenge=`echo $ChallengeXML | awk '{match($0,/>[^<>]+</); print substr($0,RSTART+1,RLENGTH-2)}'`
	# login aufbauen und hashen
	CPSTR="$Challenge-$Passwd"
	if type asc2uni >/dev/null 2>&1
	then
		asc2uni $CPSTR  > /tmp/anrufer.md5
		echo "FritzDect_timeon - asc2uni wird genutzt"
	else
		echo -n $CPSTR | iconv -f ISO8859-1 -t UTF-16LE > /tmp/anrufer.md5
		echo "FritzDect_timeon - iconv wird genutzt"
	fi	
	MD5=`md5sum /tmp/anrufer.md5 | sed -e s/' '.*$//`
	RESPONSE="$Challenge-$MD5"
	POSTDATA="login:command/response=$RESPONSE&getpage=../html/de/menus/menu2.html"
	# login senden und SID herausfischen
	SID=`wget -O - --post-data="$POSTDATA" "http://$FRITZIP/cgi-bin/webcm" 2>/dev/null| grep "name=\"sid\"" | head -1 | awk '{match($0,/value="[^"]+"/); print substr($0,RSTART+7,RLENGTH-8)}'`
	# refresh der daten auslösen
	wget -O /dev/null "http://$FRITZIP//cgi-bin/webcm?sid=$SID&getpage=..%2Fhtml%2Fde%2Fmenus%2Fmenu2.html&errorpage=..%2Fhtml%2Fde%2Fmenus%2Fmenu2.html&var%3Apagename=foncalls&var%3Aerrorpagename=foncalls&var%3Amenu=home&var%3Apagemaster=&var%3Aactivtype=pppoe&var%3AtabInetstat=0&var%3Aweckernr=&logger%3Asettings%2Ffilter=2"
	# CSV runterladen
	wget -O /tmp/fb_anrufliste.csv "http://$FRITZIP/cgi-bin/webcm?sid=$SID&getpage=..%2Fhtml%2Fde%2FFRITZ%21Box_Anrufliste.csv" 2>/dev/null
elif [ "$Version" \> "07.23" ]; then
  echo "FritzDect_timeon - neue Login-Version >=07.24"
	wget -O /tmp/anrufer.tmp http://$FRITZIP/login_sid.lua
	# SID testen
	SID=`cat /tmp/anrufer.tmp | awk '{match($0,/SID>[^<>]+</); print substr($0,RSTART+4,RLENGTH-5)}'`
	if [ "$SID" = "0000000000000000" ]; then
		# Challenge abholen
		Challenge=`cat /tmp/anrufer.tmp | awk '{match($0,/Challenge>[^<>]+</); print substr($0,RSTART+10,RLENGTH-11)}'`
		# login aufbauen und hashen
		CPSTR="$Challenge-$Passwd"
		if type asc2uni >/dev/null 2>&1
		then
			asc2uni $CPSTR  > /tmp/anrufer.md5
			echo "FritzDect_timeon - asc2uni wird genutzt"
		else
			echo -n $CPSTR | iconv -f ISO8859-1 -t UTF-16LE > /tmp/anrufer.md5
			echo "FritzDect_timeon - iconv wird genutzt"
		fi
		MD5=`md5sum /tmp/anrufer.md5 | sed -e s/' '.*$//`
		RESPONSE="$Challenge-$MD5"
		if [ "$USERNAME" = "" ]; then
			USERNAME=`cat /tmp/anrufer.tmp | awk '{match($0,/fritz[^<>]+</); print substr($0,RSTART+0,RLENGTH-1)}'`
		fi
		GETDATA="?username=$USERNAME&response=$RESPONSE"
		echo "FritzDect_timeon - Login: "$GETDATA" !"
		wget -O /tmp/anrufer.sid http://$FRITZIP/login_sid.lua$GETDATA 
		SID=$(sed -n '/.*<SID>\([^<]*\)<.*/s//\1/p' /tmp/anrufer.sid)
	fi
else
  echo "FritzDect_timeon - Login-Version >05.50 bis 7.23"
	wget -O /tmp/anrufer.tmp http://$FRITZIP/login_sid.lua?username=${USERNAME}
	# SID testen
	SID=`cat /tmp/anrufer.tmp | awk '{match($0,/SID>[^<>]+</); print substr($0,RSTART+4,RLENGTH-5)}'`
	if [ "$SID" = "0000000000000000" ]
	then
		# Challenge abholen
		Challenge=`cat /tmp/anrufer.tmp | awk '{match($0,/Challenge>[^<>]+</); print substr($0,RSTART+10,RLENGTH-11)}'`
		# login aufbauen und hashen
		CPSTR="$Challenge-$Passwd"
		if type asc2uni >/dev/null 2>&1
		then
			asc2uni $CPSTR  > /tmp/anrufer.md5
			echo "FritzDect_timeon - asc2uni wird genutzt"
		else
			echo -n $CPSTR | iconv -f ISO8859-1 -t UTF-16LE > /tmp/anrufer.md5
			echo "FritzDect_timeon - iconv wird genutzt"
		fi
		MD5=`md5sum /tmp/anrufer.md5 | sed -e s/' '.*$//`
		RESPONSE="$Challenge-$MD5"
		GETDATA="?username=$USERNAME&response=$RESPONSE"
		echo "FritzDect_timeon - Login: "$GETDATA" !"
		wget -O /tmp/anrufer.sid http://$FRITZIP/login_sid.lua$GETDATA 
		SID=$(sed -n '/.*<SID>\([^<]*\)<.*/s//\1/p' /tmp/anrufer.sid)
	fi
echo "FritzDect_timeon - Login / SessionID abgeschlossen"
fi
echo "IP:  " $FRITZIP
echo "PW:  " $Passwd
echo "ID:  " $DECT200
echo "AIN: " $teil1 $teil2
echo "SID: " $SID

#FritzDect Einschalten
wget -O /tmp/anruf.tmp "http://$FRITZIP/webservices/homeautoswitch.lua?ain=$getrennt&switchcmd=setswitchon&sid=$SID"
#FritzDect Ausschalten
#wget -O /tmp/anruf.tmp "http://$FRITZIP/webservices/homeautoswitch.lua?ain=$getrennt&switchcmd=setswitchoff&sid=$SID"

#FritzDect toggle
#wget -O /tmp/anruf.tmp "http://$FRITZIP/webservices/homeautoswitch.lua?ain=$getrennt&switchcmd=setswitchtoggle&sid=$SID"

rm /tmp/*anruf*

  else
  echo "FritzDect_timeon - NEIN - Steckdose nicht einschalten"
fi

exit 1
